
;       ___              ___           _____  ____ 
;      |   | |    |   | |     \      /   |   |     \            /
;      |___| |    |   | |___   \    /    |   |___   \    /\    /
;      |     |    |   |     |   \  /     |   |       \  /  \  /
;      |     |___ |___|  ___|    \/    __|__ |____    \/    \/ 
;
;
; Florent Peillon (mjlpeil@avo.fr)
;
;--------------------------------------------------------
;  DO NOT MAKE ANY MODIFICATION WITHOUT TELLING IT TO ME
;--------------------------------------------------------
;

	include  "doorsos.h"
	include  "compat.h"
	include  "userlib.h"
	include  "graphlib.h"
	include  "ziplib.h"
	xdef  _main
	xdef  _comment
	xdef  _ti89

_main:
  clr.w  cur_var
  clr.w  cur_fold
  clr.w  row1
folder:
  jsr  flib::clr_scr
   move.w  #0,-(a7)
   jsr  tios::FontSetSys
   add.l  #2,a7
 move.w  #4,-(a7)
 pea.l  title(PC)
 move.w  #95,-(a7)
 move.w  #0,-(a7)
 jsr  tios::DrawStrXY
 add.l  #10,a7
   move.w  #1,-(a7)
   jsr  tios::FontSetSys
   lea  2(a7),a7
 clr.l  d0
 move.w  #$08,d0
 DEREF d0,a2
 add.l    #2,a2
 clr.l      d0
 move.w   (a2),d0     ;number of folders
 subq.l     #1,d0
 lea   nb_fold(PC),a5
 move.w   (a2),(a5)
 sub.w  #1,(a5)
 add.l      #2,a2
 move.l   a2,a3
 add.l      #13,a3
 move.l   #10,d3
 lea      cur_fold(PC),a6
 clr.l    d4
 move.w   (a6),d4
 cmp.w      #11,d0
 bge      too_folders
 bra      affich_folder
 bra      vars
too_folders:
 move.l   #11,d0
affich_folder:
 movem.l    d0-d7/a0-a6,-(a7)
 move.l  d0,d5
 mulu    #8,d5
 move.l  d0,d1
 mulu    #14,d1
 move.l  d1,d2
 cmp.w     d4,d0
 beq     _inv
 clr.l  d7
 move.w  #4,d7
 bra     _aff_f
_inv:
 move.l  #0,d7
_aff_f:
 move.w  d7,-(a7)
 pea     0(a2,d1)
 move.w  d5,-(a7)
 move.w  d3,-(a7)
 jsr  tios::DrawStrXY
 lea     10(a7),a7
 movem.l    (a7)+,d0-d7/a0-a6
 dbra    d0,affich_folder
 bra vars

vars:
 lea.l  cur_fold(PC),a6
 clr.l      d5
 move.w   (a6),d5
    move.l   d5,d7
    lsl.l    #1,d7
    lsl.l    #4,d5
    sub.l    d7,d5  ;d5*14 (16-2)
 move.l   a3,a4
 add.l    d5,a4
 clr.l    d5
 move.b   (a4),d5       ;vars' hdle's number
 DEREF    d5,a2
 add.l    #2,a2
 move.w  (a2),nb_var2
 cmp.w  #0,nb_var2
 beq  key_loop
 move.w   (a2),nb_var
 sub.w  #1,nb_var
 add.l      #2,a2
;new!
 clr.l  d5
 move.w  row1,d5
; lsl.l  #1,d7
; move.l  d7,d5
; lsl.l  #3,d5
; sub.l  d7,d5
; add.l  d5,a2
;    move.l   d5,d7
;    lsl.l    #1,d7
;    lsl.l    #4,d5
;    sub.l    d7,d5  ;d5*14 (16-2)
 mulu  #14,d5
 add.l  d5,a2
 clr.l  d0
 move.w  nb_var,d0
 move.l   #120,d3
 cmp      #10,d0
 bge      too_vars
 bra      affich_var
too_vars:
 move.l   #10,d0
affich_var:
 movem.l    d0-d7/a0-a6,-(a7)
 move.l   #90,d3
 move.l  d0,d5
 mulu    #8,d5
 move.l  d0,d1
 mulu    #14,d1
 move.l  d0,d2
 add.w  row1,d2
 cmp.w     cur_var,d2
 beq     _inv1
 clr.l  d7
 move.w  #4,d7
 bra     _aff_f1
_inv1:
 move.l  #0,d7
_aff_f1:
 lea  0(a2,d1),a0
 lea  char_disp(PC),a6
 move.l  #7,d6
_aff_f2:
 cmp.b  #0,(a0)
 bne  no_esp
 move.b  #$20,(a6)
 bra  esp
no_esp:
 move.b  (a0),(a6)
esp:
 movem.l  d0-d1/a0-a1,-(a7)
 move.w  d7,-(a7)
 move.l  a6,-(a7)
 move.w  d5,-(a7)
 move.w  d3,-(a7)
 jsr  tios::DrawStrXY
 lea     10(a7),a7
 movem.l  (a7)+,d0-d1/a0-a1
 addq.l  #6,d3
 addq.l  #1,a0
 dbra  d6,_aff_f2
 movem.l    (a7)+,d0-d7/a0-a6
 dbra    d0,affich_var
 bra key_loop
 rts

key_loop:
 movem.l    d0-d7/a0-a6,-(a7)
_key:
 clr.l  d0
 move.w  #$9FFF,d0
_key_pause
 dbra  d0,_key_pause
 clr.l  d0
 move.w  (doorsos::MaxHandles+$1E),d0
 cmp.w  #337,d0
 beq  lvar
 cmp.w  #340,d0
 beq  mvar
 cmp.w  #338,d0
 beq  lfold
 cmp.w  #344,d0
 beq  mfold
 cmp.w  #264,d0
 beq  exit
 cmp.w  #13,d0
 beq  fin
 bra  _key
lfold:
 lea  cur_fold(PC),a2
 lea  cur_var(PC),a3
 clr.w  (a3)
 cmp.w  #0,(a2)
 beq  lfold_e
 sub.w   #1,(a2)
 clr.w  row1
 bra   end_key
lfold_e:
 lea  nb_fold(PC),a3
 move.w  (a3),(a2)
 clr.w  row1
 bra  end_key
mfold:
 lea  cur_fold(PC),a2
 lea  cur_var(PC),a3
 clr.w  (a3)
 lea  nb_fold(PC),a3
 clr.l  d1
 move.w  (a3),d1
 cmp.w  (a2),d1
 beq  mfold_e
 add.w  #1,(a2)
 clr.w  row1
 bra  end_key
mfold_e:
 clr.w  (a2)
 clr.w  row1
 bra  end_key
lvar:
 lea  cur_var(PC),a2
 cmp.w  #0,(a2)
 beq  lvar_e
 sub.w  #1,(a2)
;new
 cmp.w  #11,nb_var
 blt  lvar1
 clr.l  d7
 move.w  cur_var,d7
 cmp.w  row1,d7
 bgt  lvar1
 move.w  cur_var,row1
lvar1:
;
; bra  end_key
 bra  vars_go
lvar_e:
 lea  nb_var(PC),a3
 move.w  (a3),(a2)
 cmp.w  #11,nb_var
 blt  lvar_e1
 clr.l  d7
 move.w  nb_var,d7
 sub.w  #10,d7
 move.w  d7,row1
lvar_e1:
; bra  end_key
 bra  vars_go
mvar:
 lea  cur_var(PC),a2
 lea  nb_var(PC),a3
 cmp.w  (a2)+,(a3)+
 beq  mvar_e
 add.w  #1,-2(a2)
;new
 move.w  cur_var,d7
 sub.w  row1,d7
 cmp.w  #10,d7
 blt  mvar1
 move.w  cur_var,d7
 sub.w  #10,d7
 move.w  d7,row1
mvar1:
;
; bra  end_key
 bra  vars_go
mvar_e:
 clr.w  -2(a2)
 clr.w  row1
; bra  end_key
 bra  vars_go
exit:
 movem.l    (a7)+,d0-d7/a0-a6
 rts
end_key:
 movem.l    (a7)+,d0-d7/a0-a6
 bra  folder
vars_go:
 movem.l    (a7)+,d0-d7/a0-a6
 bra  vars

fin:
 movem.l    (a7)+,d0-d7/a0-a6
 cmp.w  #0,nb_var2
 beq  key_loop
 move.l  #$8,d0
 DEREF  d0,a0
 add.w  #17,a0    ;list of handle nb (folder)
 lea.l  cur_fold(PC),a1
 clr.l  d0
 move.w  (a1),d0
    move.l   d0,d7
    lsl.l    #1,d7
    lsl.l    #4,d0
    sub.l    d7,d0  ;d5*14 (16-2)
 add.l  d0,a0
 clr.l  d0
 move.b  (a0),d0
 DEREF  d0,a0  ;point to the good folder
 add.w  #17,a0
 lea.l  cur_var(PC),a1
 clr.l  d0
 move.w  (a1),d0
    move.l   d0,d7
    lsl.l    #1,d7
    lsl.l    #4,d0
    sub.l    d7,d0  ;d5*14 (16-2)
 add.l  d0,a0    ;point to the good handle's text nb
 clr.l  d0
 move.b  (a0),d0
 DEREF  d0,a0 ;point to the selectionned text
 add.w  #4,a0
 cmp.b  #$20,(a0)
 bne  notatext
 sub.w  #4,a0
 bsr affichage
 bra folder

notatext:
 bra  folder

;--------------------------------------
;  Affichage
;    a0:point to the text to show
;--------------------------------------
affichage:
 move.b  #1,first
 move.b  #0,direction
 jsr  flib::zap_screen
 move.w  #$FF,bold_var
 move.w  #0,bold_var+2
 move.l  a0,a3
 lea  end_text(PC),a1
 clr.l  (a1)
 move.w  (a3),d7
 move.w  d7,2(a1)
 move.l  a3,d7
 add.l  d7,(a1)
 addq.l  #5,a3
 move.l  a3,beginning_text
 bsr  save_lines
 subq.l  #1,d1
 move.w  d1,nb_lines
 move.l  beginning_text,a3
 lea.l  LCD_MEM,a1
 lea.l  exit_var(PC),a0
 clr.b  (a0)
 lea.l  end_var(PC),a2
 clr.b  (a2)
 lea.l  end_text(PC),a5
 move.l  (a5),d5
 bra  new

save_lines:
 move.l  #$0FA0,-(a7)
 jsr  tios::HeapAlloc
 add.l  #4,a7
 move.w  d0,handle_nb
 DEREF  d0,a0
 move.l  a0,handle_add
 clr.l  d0
 clr.l  d1
 move.w  #0,(a0)+
save_txt:
 cmp.b  #64,(a3)
 beq  spec_char
 cmp.b  #35,(a3)
 beq  spec_char
 cmp.b  #18,(a3)
 beq  spec_char
 cmp.b  #13,(a3)
 beq  line1
 cmp.l  #26,d0
 beq  line2
 addq.l  #1,a3
 addq.l  #1,d0
 cmp.l  end_text,a3
 beq  end_save
 bra  save_txt
line1:
 addq.l  #2,a3
line2:
 cmp.l  end_text,a3
 bgt  end_save
 clr.l  d0
 move.l  a3,a1
 sub.l  beginning_text,a1
 move.w  a1,(a0)+
 addq.l  #1,d1
 bra  save_txt
end_save:
 rts

spec_char:
 addq.l  #1,a3
 bra save_txt

new:
 move.l  #11,d7
 move.w  #11,line
affich_loop:
 cmp.b  #1,(a2)
 beq  _new
 bsr  ultimate
 dbra  d7,affich_loop
_new:
 bsr  keys
 cmp.b  #1,exit_var
 beq  exit_
 bra  new
exit_:
 rts

;--------------------------------------
;  Ultimate loop for display(one row)
;  a3:line to show   a1:LCD  
;  d5:end's address  a2:end_var
;--------------------------------------
ultimate:
 move.l  #7,d2
 move.l  a3,a6
 move.l  #0,d4
 move.b  d2,und_good
row:
; cmp.w  #$FF,bold_var+2
; beq  row_1
; move.w  #$1,bold_var
;row_1:
 move.l  a6,a3
 lea  l1(PC),a0
 move.l  #9,d1
effacage:
 clr.l  (a0)+
 dbra d1,effacage
 lea  l1(PC),a0
 move.l  #25,d1
enregistrage:
 cmp.l  a3,d5
 blt  text_end
 move.l  #25,d6
 sub.l  d1,d6
 bsr  spec_font
 clr.l  d3
 move.b  (a3)+,d3
 cmp.b  #$0D,d3
 beq  end_lign
 lsl.l  #3,d3
 lea.l  char(PC),a4
; lea  7(a4,d3),a4
; sub  d2,a4
 add.l  d3,a4
 add.l  d4,a4
 move.b  (a4),(a0)+
 bsr  spec_font_do
 dbra  d1,enregistrage
_back:
 lea  -1(a3),a3
end_lign:
; bsr  last_char
 move.w  #$FF,bold_var
 move.w  #$FF,inv_var
 move.w  #$FF,und_var
 lea  1(a3),a3
 addq.l  #1,d4
 lea  l1(PC),a0
 move.l  #7,d1
decalage:
 clr.l  d0
 move.b  (a0)+,d0
 lsl.w  #6,d0
 move.b  (a0),d0
 lsr.w  #6,d0
 move.b  d0,(a1)+
 clr.l  d0
 move.b  (a0)+,d0
 lsl.w  #6,d0
 move.b  (a0),d0
 lsr.w  #4,d0
 move.b  d0,(a1)+
 clr.l  d0
 move.b  (a0)+,d0
 lsl.w  #6,d0
 move.b  (a0)+,d0
 lsr.w  #2,d0
 move.b  d0,(a1)+
 dbra  d1,decalage
 subq.b  #1,und_good
 add.l  #6,a1
 dbra  d2,row
 rts
text_end:
 move.b  #1,(a2)
 bra _back

spec_font:
 cmp.b  #$40,(a3)
 bne  underlined
 addq.l  #1,a3
 cmp.w  #$FF,bold_var
 beq  _un1
 move.w  #$FF,bold_var
 bra  spec_font
_un1:
 move.w  d6,bold_var
 bra  spec_font
underlined:
 cmp.b  #$12,(a3)
 bne  invert
 addq.l  #1,a3
 cmp.w  #$FF,und_var
 beq  _in1
 move.w  #$FF,und_var
 bra  spec_font
_in1:
 move.w  d6,und_var
 bra  spec_font
invert:
 cmp.b  #$23,(a3)
 bne  spec_font_exit
 addq.l  #1,a3
 cmp.w  #$FF,inv_var
 beq  _ex1
 move.w  #$FF,inv_var
 bra  spec_font
_ex1:
 move.w  d6,inv_var
 bra  spec_font
spec_font_exit:
 rts

spec_font_do:
 lea  -1(a0),a5
 cmp.w  #$FF,bold_var
 beq  spec_font_d1
 clr.l  d3
 move.b  (a5),d3
 lsl.l  #1,d3
 or.b  d3,(a5)
spec_font_d1:
 cmp.w  #$FF,und_var
 beq  spec_font_d2
 cmp.b  #0,und_good
 bne  spec_font_d2
 move.b  #$FF,(a5)
spec_font_d2:
 cmp.w  #$FF,inv_var
 beq spec_font_d3
 eor.b  #$FF,(a5)
spec_font_d3:
 rts
 
;--------------------------------------
; Keys loop
;--------------------------------------
keys:
 movem.l  d0-d1/a0-a1,-(a7)
_keys2:
 cmp.b #$0F,speed
 bge  super_fast
 clr.l  d0
 move.w  #$FFFF,d0
 clr.l  d1
 move.b  speed,d1
 lsl.l  #6,d1
 lsl.l  #6,d1
 sub.l  d1,d0
_wait1:
 dbra d0,_wait1
super_fast:
 clr.l   d0
 move.w  (doorsos::MaxHandles+$1E),d0
 cmp.w  #338,d0
 beq  _page_up
 cmp.w  #344,d0
 beq  _page_down
 cmp.w  #337,d0
 beq  _up
 cmp.w  #340,d0
 beq  _down
 cmp.w  #266,d0
 beq  shut_down
 cmp.w  #277,d0
 beq  _exit
 cmp.w  #257,d0
 beq  _go_beginning
 cmp.w  #263,d0
 beq  _go_end
 cmp.w  #43,d0
 beq  speed_up
 cmp.b  #45,d0
 beq  speed_down
 bra  _keys2
_exit:
 movem.l  (a7)+,d0-d1/a0-a1
 lea  exit_var(PC),a0
 move.b  #1,(a0)
 move.w  handle_nb,-(a7)
 jsr  tios::HeapFree
 add.l  #2,a7
 rts

_down:
 cmp.b  #0,direction
 beq  good_down
 clr.l  d0
 move.w  line,d0
 add.l  #11,d0
 cmp.w  nb_lines,d0
 bge  _keys2
 move.b  #0,direction
 clr.l  d7
 add.w  #12,line
 move.w  line,d7
 lsl.l  #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 bra  _do
good_down:
 clr.l d0
 move.w  line,d0
 subq.l  #1,d0
 cmp.w  nb_lines,d0
 bge  _keys2
 add.w  #1,line
_do:
; cmp.l  end_text,a3
; bge  _keys2
 bsr up_shift
 lea.l  LCD_MEM,a1
 add.l  #2640,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 bsr  ultimate
 bra  _keys2

_up:
 cmp.b  #1,direction
 beq  good_up
 cmp.w  #11,line
 ble  _keys2
 move.b  #1,direction
 clr.l  d7
 sub.w  #12,line
 move.w  line,d7
 lsl.l  #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 bra  _u
good_up:
 cmp.w  #1,line
 blt  _keys2
 sub.w  #1,line
 move.l  handle_add,a0
 move.w  line,d7
 lsl.l  #1,d7
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
_u:
; cmp.l  beginning_text,a3
; ble  _keys2
 bsr down_shift
 lea.l  LCD_MEM,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 bsr  ultimate
 bra  _keys2
 
_page_down:
 cmp.b  #0,direction
 beq  good_page_down
 clr.l  d0
 move.w  line,d0
 add.l  #11,d0
 cmp.w  nb_lines,d0
 bge  _keys2
 move.b  #0,direction
 clr.l  d7
 add.w  #12,line
 move.w  line,d7
 lsl.l  #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 bra  _p_do
good_page_down:
 clr.l d0
 move.w  line,d0
 subq.l  #1,d0
 cmp.w  nb_lines,d0
 bge  _keys2
 add.w  #1,line
_p_do:
 lea.l  LCD_MEM,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 move.l  #11,d7
 add.w  #11,line
affich_loop2:
 bsr  ultimate
 dbra  d7,affich_loop2
 bra  _keys2

_page_up:
 cmp.b  #0,direction
 beq  good_page_up
 cmp.w  #12,line
 ble  _p_u_beginning
 move.b  #0,direction
 sub.w  #12,line
 bra  _p_u
_p_u_beginning:
 cmp.w  #1,line
 blt  _keys2
 move.w  #0,line
 move.b  #0,direction
 bra  _p_u
good_page_up:
 cmp.w  #23,line
 ble  _p_u_beginning
 sub.w  #23,line
_p_u:
 clr.l  d7
 move.w  line,d7
 lsl.l #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 lea.l  LCD_MEM,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 move.l  #11,d7
 add.w  #11,line
affich_loop3:
 bsr  ultimate
 dbra  d7,affich_loop3
 bra  _keys2

up_shift:
 movem.l  a0-a1/d0,-(a7)
 lea  LCD_MEM,a0
 move.l  a0,a1
 add.l  #240,a1
 move.l  #659,d0
_up_sh:
 move.l  (a1)+,(a0)+
 dbra  d0,_up_sh
 movem.l  (a7)+,a0-a1/d0
 rts

down_shift:
 movem.l  a0-a1/d0,-(a7)
 lea.l  LCD_MEM,a0
 add.l  #2640,a0
 move.l  a0,a1
 add.l  #240,a1
 move.l  #659,d0
_down_sh:
 move.l  -(a0),-(a1)
 dbra  d0,_down_sh
 movem.l  (a7)+,a0-a1/d0
 rts

_go_beginning:
 move.w  #0,line
 clr.l  d7
 move.w  line,d7
 lsl.l #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 lea.l  LCD_MEM,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 move.l  #11,d7
 add.w  #11,line
affich_loop4:
 bsr  ultimate
 dbra  d7,affich_loop4
 move.b  #0,direction
 bra  _keys2

_go_end:
 cmp.w  #12,nb_lines
 ble  _go_beginning
 move.w  nb_lines,line
 sub.w  #10,line
 clr.l  d7
 move.w  line,d7
 lsl.l #1,d7
 move.l  handle_add,a0
 add.l  d7,a0
 move.l  beginning_text,a3
 add.w  (a0),a3
 lea.l  LCD_MEM,a1
 lea.l  end_var(PC),a2
 clr.b  (a2)
 move.l  end_text,d5
 move.l  #11,d7
 add.w  #11,line
affich_loop5:
 bsr  ultimate
 dbra  d7,affich_loop5
 move.b  #0,direction
 bra  _keys2

shut_down:
 trap  #4
 clr.w  (doorsos::MaxHandles+$1E)
 bra  _keys2

speed_up:
 cmp.b  #$0F,speed
 bge _keys2
 add.b  #1,speed
 bra  _keys2

speed_down:
 cmp.b  #0,speed
 ble  _keys2
 sub.b  #1,speed
 bra  _keys2

;erreur12:
; movem.l  d0-d7/a0-a6,-(a7)
; move.w  #1,-(a7)
; jsr  tios::FontSetSys
; lea  2(a7),a7
; move.w  #1,-(a7)
; pea  erreur1(PC)
; move.w  #30,-(a7)
; move.w  #30,-(a7)
; jsr  tios::DrawStrXY
; lea  10(a7),a7
; jsr  flib::idle_loop
; movem.l  (a7)+,d0-d7/a0-a6
; rts

;----------- var & cte ---------------
end_text        dc.l  0
beginning_text  dc.l  0
handle_add      dc.l  0
cur_var     dc.w   0
cur_fold    dc.w   0
nb_fold     dc.w   0
line		dc.w   0
nb_var      dc.w   0
nb_var2     dc.w   0
add_txt     dc.w   0
last_key    dc.w  264
bold_var    dc.w  $FF,0
inv_var     dc.w  $FF,0
und_var     dc.w  $FF
keyscan     dc.w  0,0,0,0,0
nb_lines    dc.w  0
row1        dc.w  0
char_disp   dc.w  0
handle_nb   dc.w  0
l1  ds.b  40
speed       dc.b  5
und_good    dc.b  0
;erreur1  dc.b  "osdfff",0
end_var  dc.b  1
exit_var  dc.b  0
first  dc.b  0
direction  dc.b  0  ;if 0 down , if 1 up
title  dc.b  "PV v0.10 Florent Peillon MJLPEIL@AVO.FR",0

;----- include files (the font) ------
include  plusview.fo1


_comment   dc.b  "PV v0.10 by Florent Peillon",0

	end
